/*
 *
 * RapidWeaver Multi Language Enclosure stack by Tsooj Media
 * Version 1.1.2
 *
 * Visit http://www.tsooj.net for more information on how to use this stacks product for RapidWeaver.
 *
 */
  
 if (!atm_strRWMLVersion) {
	var atm_strRWMLVersion = 'v1.1.2'; 	
 
	 /**
	   * Based on the Cookie plugin
	   *
	   * Copyright (c) 2006 Klaus Hartl (stilbuero.de)
	   * Dual licensed under the MIT and GPL licenses.
	   *
	   */
	  (function($){
	  	$.cookie = function(key, value, options) {
	  		if(arguments.length > 1) {
	  			var o = $.extend({}, $.cookie.defaults, options);
	  	        if (value === null || value === undefined) {
	  	            value = '';
	  	            o.expires = -1;
	  	        }
	  	        if (o.expires.constructor != Date) {
	  				var today = new Date();
	  				today.setDate(today.getDate() + o.expires);
	  				o.expires = today;
	  			}
	  			// Create the cookie string
	  			document.cookie = 
	  				key + '=' + value +
	  				'; expires=' + o.expires.toUTCString() +
	  				(o.path? '; path=' + (o.path) : '') +
	  				(o.domain? '; domain=' + (o.domain) : '') +
	  				(o.secure? '; secure' : '');
	  		} else {
	  			if(result = new RegExp(key+"=(.*?)(?:;|$)").exec(document.cookie))
	  				return decodeURIComponent(result[1]);
	  			return false;
	  		}
	  	};
	  	$.cookie.defaults = {
	  		expires: ((%id=cookieExpire% == 0) ? -1 : %id=cookieExpire%),
	  		path: '/',
	  		domain: document.domain,
	  		secure: ((document.location.protocol == 'https:') ? true : false)
	  	}
	  })(jQuery);
	  
	 
	 // Try to correct possible usage of special characters.
	 function atm_decodeHTMLEntities (strString) { return $('<textarea />').html(strString).val(); }
	 
	 // Text Equals to function.
	 $.fn.textEquals = function(strText) { return $(this).text() == strText; }
	 
	 // Get URL Parameter.
//	 function atm_GetUrlParameter(strParameter){
//	 	var objParams = new RegExp('[\\?&]' + strParameter + '=([^&#]*)').exec(window.location.href);
//	 	if (!objParams) { return ''; }
//	 	return new String(objParams[1]) || '';
//	 }
	 function atm_GetUrlParameter(){
		var atm_strRwmlUrlParameters = ['lang', 'language', 'rwml'];
	 	var strParameter = '', strLocation, iCounter;
	 	
		strLocation = window.location.href;
		
		
		for (iCounter = 0; iCounter < atm_strRwmlUrlParameters.length; ++iCounter){ 
			var objParam = new RegExp('[\\?&]' + atm_strRwmlUrlParameters[iCounter] + '=([^&#]*)').exec(strLocation);
			if ((strParameter == '') && (objParam)) {
				strParameter = new String(objParam[1]) || '';
		 	}
		}
		return strParameter;
	 }
	 
	 // Global Vars.
	 stacks.atm_gstrRwmlCurrentLanguage = '';
	  
	 // Local Vars.
	 var atm_strRwmlDefaultLanguage = '%id=defaultLanguage%';
	 	atm_strRwmlCookieName = 'rwml_preferred_language',
	 	atm_strRwmlUrlParameter = 'rwml',
	 	atm_strRwmlCurrentLanguage = '',
	 	atm_strRwmlLanguageOverride = '',
	 	atm_strRwmlRequiredLabelHTML = '',
	 	atm_strRwmlRequiredLabelText = '',
	 	atm_blnRwmlHandleSubmitButton = false,
	 	atm_blnRwmlHanldeRedirects = false,
	 	atm_blnRwmlMenuItemsSpanBased = false,
	 	atm_blnRwmlFormloomRequiredLabels = false,
	 	atm_arrRwmlSubmitButtonTranslations = {},
	 	atm_arrRwmlRedirectURLs = {};
	 	
	 
	 function atm_rwmlShowLanguage(strLanguage, blnDocumentReady) {
	 	
	 	 /**	Hide all language content, note that a lot of RW Themes come with a wrong html xml declaration.
	 	 		For example: <html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">.
	 	 		So therefore we are using the specific document.body target for the Lang(uage) selection, 
	 	 		otherwise the entire document content could be hidden by the RWML system.
	 	 */
	 	 
	 	// Only perform actions when a different Language is chosen.
	 	if (atm_strRwmlCurrentLanguage != strLanguage) { 
	 
	 		$('[lang]', document.body).hide();
	 	
	 		// Show Selected Language, fade in when Switching from Language.
	 		$('[lang]', document.body).each(function() {
	 			if (($(this).attr('lang') == strLanguage) && blnDocumentReady) { $(this).show(); } 
	 			else if (($(this).attr('lang') == strLanguage) && !blnDocumentReady) { $(this).fadeIn(%id=fadeinSpeed%); }
	 			else { $(this).hide(); }		
	 		}); 	
	 	
	 		// Make sure that a used RWML Dropdown Select element is showing the correct Language.
	 		if ($('#rwml-dropdown-switch').prop('value') != strLanguage) { $('#rwml-dropdown-switch').prop('value', strLanguage); }
	 		
	 		// Submit Button Translation.
	 		if ((atm_blnRwmlHandleSubmitButton) && (strLanguage in atm_arrRwmlSubmitButtonTranslations)) { 
	 			$('input[name="submitButton"]').attr('value', atm_arrRwmlSubmitButtonTranslations[strLanguage]); 
	 			$('input[class="fl-submit"]').attr('value', atm_arrRwmlSubmitButtonTranslations[strLanguage]); // Formloom v2 
	 		}
	 	
	 		// Show all RWML system (rwml-sys) contained Language content items.
	 		if (atm_strRwmlCurrentLanguage == '') { $('.rwml-sys').show(); }
	 		
	 		// Set the Active Language;
	 		atm_strRwmlCurrentLanguage = strLanguage;
	 			
	 		// Make sure the Cookie is renewed.
	 		$.cookie(atm_strRwmlCookieName, null);
	 
	 		// Set the Active Language, Cookie event...
	 		atm_strRwmlCurrentLanguage = strLanguage;
	 
	 		// Store used Language in RWML Cookie.  
	 		$.cookie(atm_strRwmlCookieName, strLanguage);	
	 
	 		// Handle Redirects when needed, on document ready directly redirect otherwise use the given redirect delay.
	 		if (atm_blnRwmlHanldeRedirects && !blnDocumentReady) { setTimeout(function(){atm_rwmlRedirect(atm_strRwmlCurrentLanguage)}, %id=redirectDelay%); } 
	 		if (atm_blnRwmlHanldeRedirects && blnDocumentReady) { atm_rwmlRedirect(atm_strRwmlCurrentLanguage); }	
	 	}
	 } 
	 
	 
	 // Document Ready Actions.
	 
	 function atm_DocumentReadyActions() {
	 
	 	// Replace Menu Items. 
	 	$('div[class="rwml-menu-item"]').each(function() {
	 		var atm_strMenuItemTitle = atm_decodeHTMLEntities($(this).attr('TITLE'));
	 		var atm_strMenuItemHTML = $(this).html();
	 		
	 		// Menu Items Text or Span based.
	 		if (atm_blnRwmlMenuItemsSpanBased == false) {
	 			$('a').each(function() {
	 				var atm_strMenuItemText = atm_decodeHTMLEntities($(this).text());
	 				var atm_strMenuItemIncludingHTML = atm_decodeHTMLEntities($(this).html());
	 				if (atm_strMenuItemText == atm_strMenuItemTitle) { 
	 					if (atm_strMenuItemText != atm_strMenuItemIncludingHTML) {
	 						$(this).html(atm_strMenuItemIncludingHTML.replace(atm_strMenuItemTitle, atm_strMenuItemHTML));					
	 					} else {
	 						$(this).html(atm_strMenuItemHTML); 
	 					}
	 				}
	 			});
	 			
	 		  // Span based.
	 		} else {
	 			$('.'+atm_strMenuItemTitle).replaceWith(atm_strMenuItemHTML);
	 		}
	 		$(this).remove();
	 	});
	 	
	 	// Remove Imported Menu Definitions
	 	$('div[class="rwml-menu-imported"]').each(function() { $(this).remove(); });
	 
	 	// Formloom v2 specific.
	 	if ($('span[class="ydfl-required-symbol"]').length > 0) { 
	 		atm_blnRwmlFormloomRequiredLabels = true; 
	 		atm_strRwmlRequiredLabelHTML = $('<div>').append($('span[class="ydfl-required-symbol"]').first().clone()).html();
	 		atm_strRwmlRequiredLabelText = $('span[class="ydfl-required-symbol"]').first().html();
	 	}
	 	
	 	// Replace Contact Form Labels.
	 	$('div[class="rwml-label-item"]').each(function() {
	 		var atm_strLabelItemTitle = atm_decodeHTMLEntities($(this).attr('TITLE'));
	 		var atm_strLabelItemHTML = $(this).html();
	 		
	 		$('label').each(function() {
	 			
	 			var atm_strLabelItemText = atm_decodeHTMLEntities($(this).text());
	 		
	 			// When a Formloom v2 required span is used we should add that one back into the total label.
	 			// Note that the Formloom plugin adds a space character and a span that contains the required character(s).			
	 			if (atm_blnRwmlFormloomRequiredLabels && (atm_strLabelItemText == (atm_strLabelItemTitle + ' ' + atm_strRwmlRequiredLabelText))) { $(this).replaceWith(atm_strLabelItemHTML.replace(/<\/label>/gi, ' ' + atm_strRwmlRequiredLabelHTML + '</label>')); }
	 			
	 			// Normal Built-in Contact Form and the Freestacks Theme Contact Form.
	 			if (atm_strLabelItemText == atm_strLabelItemTitle) { $(this).replaceWith(atm_strLabelItemHTML); }
	 		});
	 		$(this).remove();
	 	});
	 
	 	// Remove Contact Form Items placeholder.
	 	$('div[class="rwml-contact-form"]').remove();
	 		
	 	// Contact Form Button(s).
	 	$('span[class="rwml-submit-button-span"]').each(function() {
	 		var atm_strSubmitButtonLang = $(this).attr('LANG');
	 		atm_arrRwmlSubmitButtonTranslations[atm_strSubmitButtonLang] = $(this).html();
	 		atm_blnRwmlHandleSubmitButton = true;
	 	});	
	 	
	 	// Remove Contact Form Button(s) placeholder.
	 	$('div[id="rwml-contact-form-buttons"]').remove();
	 	 
	  	// Create Switch Links based on the RWML Switch Stack(s).
	 	$('a[rel="rwml"]').click(function() {
	 		var atm_strHrefLang = $(this).attr('HREFLANG');
	 		atm_rwmlShowLanguage(atm_strHrefLang, false);
	 		$('#rwml-dropdown-switch').attr('value', atm_strRwmlCurrentLanguage);
	 		return false; // Disable default behaviour.
	     });
	     
	     // Create Switch Links based on the Toolbar aka Menu Items.
	 	$('a[href*="rwml-sys"]').click(function() {
	 		var atm_strHrefLang = $(this).text();
	 		atm_rwmlShowLanguage(atm_strHrefLang, false);
	 		$('#rwml-dropdown-switch').attr('value', atm_strRwmlCurrentLanguage);
	 		return false; // Disable default behaviour.
	 	});
	 	
	 	// Create Switch Links based on Image Maps.
	 	$('area[rel="rwml"]').click(function() {
	 		var atm_strHrefLang = $(this).attr('HREFLANG');
	 		atm_rwmlShowLanguage(atm_strHrefLang, false);
	 		$('#rwml-dropdown-switch').attr('value', atm_strRwmlCurrentLanguage);
	 		return false; // Disable default behaviour.
	 	});
	 		
	 	// Handle Redirects.
	 	if ($('div[id="rwml-redirect"]').length > 0) { atm_blnRwmlHanldeRedirects = true; };
	 	//$('span[class="rwml-redirect-item"]').each(function() {
	 		// Add new redirect system.
	 	//});	
	     
	     // Show the 'Selected' Language based on Autoselect or URL override parameter.
	     // Move Autoselect to normal true false so that it can also be used to hide other not in rwml-sys placed content.
	 	atm_strRwmlLanguageOverride = atm_GetUrlParameter(atm_strRwmlUrlParameter);
	 	if (atm_strRwmlLanguageOverride == '') {
	 		%id=autoSelect%
	 	} else {
	 		atm_rwmlShowLanguage(atm_strRwmlLanguageOverride, true);
	 	}
	 	
	 	// Create Swith Based on the RWML Dropdown Select element and set the correct (start) Language.
	 	$('#rwml-dropdown-switch').prop('value', atm_strRwmlCurrentLanguage);
	 	$('#rwml-dropdown-switch').change(function() {
	 		atm_rwmlShowLanguage($(this).prop('value'), false);
	 	});
	 
	 }
	 
	 
	 // Hide the Language Content items that belong to the RWML system (rwml-sys) during page load.
	 // This prevents that the Content comes available during page loading.
	 document.write("<style type='text/css'>.rwml-sys {display: none;}</style>"); 
	 
	 
	 // Perform all actions on Document Ready.
	 $(document).ready(function() {   
	 	
	 	if (%id=delayed% == true) { setTimeout(function(){atm_DocumentReadyActions()}, %id=startDelay%); } else { atm_DocumentReadyActions(); }
	 	
	 });
	 

 };
 
 
 